


(function() {
   tinymce.create('tinymce.plugins.infographic.shortcodes', {
      init: function(ed, url) {

         var availableFonts = InfographicAvailableFonts();


         ed.addButton('infographic-chart', {
            title: 'Infographic Chart',
            image: url + '/../img/chart.png',
            onclick: function() {
               
               var initialChartType = 'piechart';
               var _initialOb = {};
               var _initialCustomOb = {size:{width:250, height:250}, lineWidth:2, pointSize:4};
               var crtSel = ed.selection.getNode().innerHTML;
               var editMode = false;
               if (crtSel.indexOf('[infographic-')>=0){
                  editMode = true;
                  var re = /\[infographic-(\w+)\s*(([a-zA-Z_]+=["'].*?["']\s*)*)*\](.*)\[\/infographic-\1\]/;
                  var res = [];
                  if (crtSel.match(re)){
                     //has content
                     res = re.exec(crtSel);
                     var content = res[4];
                     var piesliceRe = /\[ig-pieslice\s*label=["'](.*?)["']\s*value=["'](.*?)["']\]/g;
                     var lineBarRe = /\[ig-(line|bargroup)\s*name=["'](.*?)["']\s*\](.*?)\[\/ig-\1\]/g;
                     if (content.match(piesliceRe)){
                        while ((att = piesliceRe.exec(content)) !== null){
                           if (typeof(_initialOb.slices)=='undefined'){
                              _initialOb.slices = [];
                           }
                           _initialOb.slices.push({label:att[1],value:att[2]});
                        }
                     }else if (content.match(lineBarRe)){
                        while ((att = lineBarRe.exec(content)) !== null){

                           if (typeof(_initialOb.barGroup)=='undefined'){
                                    _initialOb.barGroup = [];
                                    _initialOb.line = [];
                           }

                           var barGroup = {name:att[2], bar:[]};
                           var line = {name:att[2], point:[]};

                           var barPointRe = /\[ig-(bar|point)\s*label=["'](.*?)["']\s*value=["'](.*?)["']\]/g;
                           while ((attInner = barPointRe.exec(att[0])) !== null){
                              
                                 var bar = {label:attInner[2], value:attInner[3]};
                                 var point = {label:attInner[2], value:attInner[3]}

                                 barGroup.bar.push(bar);
                                 line.point.push(point);
                              
                           }
                           _initialOb.barGroup.push(barGroup);
                           _initialOb.line.push(line);
                        }
                     }

                  }else{
                     //no content
                     re = /\[infographic-(\w+)\s*(([a-zA-Z_]+=["'].*?["']\s*)*)\]/;
                     res = re.exec(crtSel);
                     var attrsRe = /((\w+)=['"](.*?)['"])/g;
                     
                  }

                  var attrsRe = /((\w+)=['"](.*?)['"])/g;
                     
                  while ((att = attrsRe.exec(res[2])) !== null){
                     if (att[2] == 'width' || att[2] == 'height'){
                        if (typeof(_initialOb.size)=='undefined'){
                           _initialOb.size = {};
                           _initialCustomOb.size = {};
                        }
                        _initialOb.size[att[2]] = att[3];
                        _initialCustomOb.size[att[2]] = att[3];
                     } else if(att[2] == "colors"){
                        _initialCustomOb.colors = att[3].split(",");
                     } else if (att[2].indexOf("font_")==0){
                        
                        att[2] = att[2].replace(/(_(.))/g,function (g1, g2, g3){return g3.toUpperCase()});
                        if (typeof(_initialCustomOb.font) == 'undefined'){
                           _initialCustomOb.font = {};
                        }
                        _initialCustomOb.font[att[2]] = att[3];
                     } else if (att[2].indexOf("grid_")==0){
                        
                        att[2] = att[2].replace(/(_(.))/g,function (g1, g2, g3){return g3.toUpperCase()});
                        if (typeof(_initialCustomOb.gridOptions) == 'undefined'){
                           _initialCustomOb.gridOptions = {};
                        }
                        _initialCustomOb.gridOptions[att[2]] = att[3];
                     } else if (att[2].indexOf("label_")==0){
                        
                        att[2] = att[2].replace(/(_(.))/g,function (g1, g2, g3){return g3.toUpperCase()});
                        if (typeof(_initialCustomOb.labels) == 'undefined'){
                           _initialCustomOb.labels = {};
                        }
                        _initialCustomOb.labels[att[2]] = att[3];
                     } else if (att[2] == 'data_csv'){
                        _initialOb.csvUrl = att[3];
                     } else{
                        att[2] = att[2].replace(/(_(.))/g,function (g1, g2, g3){return g3.toUpperCase()});
                        _initialOb[att[2]] = att[3];
                        _initialCustomOb[att[2]] = att[3];
                     }
                  }
                  
                  initialChartType = res[1];
               }

               var ChartData = InfographicDataModels[initialChartType];
               var dataOb = new ChartData(_initialOb);

               var ChartCustomization = InfographicProperties[initialChartType];
               var customizationOb = new ChartCustomization(_initialCustomOb);

               var formData = new Backbone.Form({
                   model: dataOb
                }).render();

               var formCustomization = new Backbone.Form({
                   model: customizationOb
                }).render();
               jQuery("#myFancyDialog").remove();
               var dlg = jQuery(
                  "<div id='myFancyDialog' style='padding:10px;' title='Insert infographic' >\
                  Chart type: <select class='chartTypeSelector'>\
                  <option value='piechart'>Piechart / Doughnut</option>\
                  <option value='shapebargraph'>Shape Bar</option>\
                  <option value='shapegraph'>Shape Graph</option>\
                  <option value='linegraph'>Line Graph</option>\
                  <option value='bargraph'>Bar Graph</option>\
                  </select>\
                  <br/><span>(<a target='_blank' href='http://www.coding-dude.com/wp/projects/infographic-charts-graphics-html-tags-library/'>Infographic Library Project Page</a> for attributes explanation)</span>\
                  <h4 class='toggleSection'  data-target='.chartCustomization, .chartData'>1. Chart Data <span>-</span></h4>\
                  <div class='chartData'></div>\
                  <h4 class='toggleSection'  data-target='.chartCustomization, .chartData'>2. Customization Options <span>+</span></h4>\
                  <div class='chartCustomization'></div>\
                  </div>")
                  .appendTo("body");
               dlg.formData = formData;
               dlg.formCustomization = formCustomization;
               dlg.find(".chartData").html(formData.el);
               dlg.find(".chartCustomization").html(formCustomization.el);
               dlg.find(".availableFonts").autocomplete({source: availableFonts});

               dlg.find(".toggleSection").click(function(){
                  var self = this;
                  var $self = jQuery(self);
                  jQuery($self.attr("data-target")).toggle();
                  $toggleHeader = $self.parent().find(".toggleSection span");
                  $toggleHeader.each(function (idx, el){
                     jQuery(el).html(jQuery(el).html()=="+"?"-":"+")   
                  })
                  
               });
               dlg.find(".chartTypeSelector").val(initialChartType);
               dlg.find(".chartTypeSelector").change(function (){
                  var $self = jQuery(this);
                  var selectedChart = $self.find("option:selected").val();
                  
                  var ChartData = InfographicDataModels[selectedChart];
                  var dataOb = new ChartData(_initialOb);

                  var ChartCustomization = InfographicProperties[selectedChart];
                  var customizationOb = new ChartCustomization(_initialCustomOb);

                  var formData = new Backbone.Form({
                  model: dataOb
                  }).render();

                  var formCustomization = new Backbone.Form({
                  model: customizationOb
                  }).render();
                  dlg.formData = formData;
                  dlg.formCustomization = formCustomization;
                  dlg.find(".chartData").html(formData.el);
                  dlg.find(".chartCustomization").html(formCustomization.el);
                  dlg.find(".availableFonts").autocomplete({source: availableFonts});
               });

               dlg.dialog({
                  'dialogClass': 'wp-dialog',
                  'modal': true,
                  'autoOpen': false,
                  'width':'450px',
                  'closeOnEscape': true,
                  'buttons':

                  [{
                     'text': editMode?'Update':'Insert',
                     'class': 'button-primary',
                     'click': function() {
                        dlg.formCustomization.commit();
                        var _cust = dlg.formCustomization.getValue();
                        // console.log(_cust);

                        dlg.formData.commit();
                        var _data = dlg.formData.getValue();
                        // console.log(_data);

                        var val = InfographicDataModels.transform(_cust,_data, dlg.formCustomization.model.defaults);
                        if (editMode){
                           ed.selection.getNode().innerHTML = val;
                        }else{
                           ed.execCommand('mceInsertContent', false,
                              val
                           );
                        }
                        
                        jQuery(this).dialog('close');
                     }
                  },
                  {
                     'text': 'Close',
                     'class': 'button-default',
                     'click': function() {
                        jQuery(this).dialog('close');
                     }
                  }]
               }).dialog('open');
            }
         });
      },
      createControl: function(n, cm) {
         return null;
      },
      getInfo: function() {
         return {
            longname: "Infographic Chart",
            author: 'John Negoita',
            authorurl: 'http://www.coding-dude.com',
            infourl: 'http://www.coding-dude.com',
            version: "1.0"
         };
      }
   });
   tinymce.PluginManager.add('infographic.shortcodes', tinymce.plugins.infographic.shortcodes);
})();




var InfographicSubmodels = {
   FontModel:Backbone.Model.extend({
      schema:{
         fontFamily: {type:"Text", editorAttrs:{style:"width:80px;"}, title:"", editorClass:"availableFonts"},
         fontSize: {type:"Text", editorAttrs:{style:"width:50px;"}, title:""},
         fontWeight: {type: "Select", options:["normal","bold"], title:""},
         fontColor: {type:"ColorEditor", editorAttrs:{style:"width:10%;"},title:""}
      }
   }),
   GridOptionsModel:Backbone.Model.extend({
      schema:{
         gridFontFamily: {type:"Text", editorAttrs:{style:"width:80px;"}, title:"", editorClass:"availableFonts"},
         gridFontSize: {type:"Text", editorAttrs:{style:"width:50px;"}, title:""},
         gridFontWeight: {type: "Select", options:["normal","bold"], title:""},
         gridColor: {type:"ColorEditor", editorAttrs:{style:"width:10%;"},title:""},
         gridScale:{type:"Number", editorAttrs:{style:"width:40px;"}},
         gridLineWidth:{type:"Number", editorAttrs:{style:"width:40px;"}},
      }
   }),
   LabelsModel:Backbone.Model.extend({
      schema:{
         labelType: {type: "Select", options:["percent","value"], title:""},
         labelDecimals: {type:"Number", editorAttrs:{style:"width:30px;"}, title:"Decimals"},
         labelUnit: {type:"Text", editorAttrs:{style:"width:50px;"},title:"Units"}
      }
   })
   ,
   SizeModel:Backbone.Model.extend({
      schema:{
         width: {type: "Number", editorAttrs:{style:"width:80px;"}, title:"", help:"x"},
         height: {type:"Number", editorAttrs:{style:"width:80px;"}, title:"", help:"px"}
      }
   })
}

var InfographicPieSlice = {
   label:"Label",
   value:0.1
};

var InfographicProperties =
{

      "piechart": Backbone.Model.extend({
         schema:{
         id : {type:"Text", editorAttrs:{style:"width:100px;"}, fieldClass:"inlineField"},
         type : {
            type: 'Select', options: ["pie","doughnut"], fieldClass:"inlineField"
         },

         holeSize:{type:"Number", fieldClass:"inlineField", editorAttrs:{style:"width:50px;",step:0.1, maxvalue:1}},
         padding:{type:"Number", fieldClass:"inlineField",editorAttrs:{style:"width:50px;"}, fieldAttrs:{style:"display:block;"},help:"px"},
         highlightMode:{type:'Select',options:["default","pop","border"],fieldClass:"inlineField"},
         highlightSize:{type:"Number", fieldClass:"inlineField", editorAttrs:{style:"width:50px;"}},
         font: {type:'NestedModel',model: InfographicSubmodels.FontModel, fieldClass:"NestedModel", help:"can also be WebFonts"},
         labels: {type:'NestedModel',model: InfographicSubmodels.LabelsModel, fieldClass:"NestedModel"},
         size: {type:'NestedModel',model: InfographicSubmodels.SizeModel, fieldClass:"NestedModel"},
         colors: {type:'List', itemType:'ColorEditor',fieldClass:"inlineField"}
         },
         defaults: {
            type:"pie",
            font:{
               fontSize : "16px",
               fontWeight : "bold",
               fontFamily : "sans-serif",
               fontColor:"#ffffff"
            },
            labels:{
               labelDecimals:2,
               labelType:"percent",
               labelUnit:""
            },
            size:{
               width : 500,
               height : 500
            },
            holeSize:0.5,
            padding:0,
            highlightMode:"default",
            highlightSize:4,
            colors:["#000000"]
         }
      }),
      "shapebargraph": Backbone.Model.extend({
               schema:
               {
                  id : {type:"Text", editorAttrs:{style:"width:100px;"}, fieldClass:"inlineField"},
                  image : {type:'Text', title:"Image URL", editorAttrs:{style:"width:100%;"}},        
                  font: {type:'NestedModel',model: InfographicSubmodels.FontModel, fieldClass:"NestedModel", help:"can also be WebFonts"},
                  size: {type:'NestedModel',model: InfographicSubmodels.SizeModel, fieldClass:"NestedModel"},
                  fillColor: {type:"ColorEditor", fieldClass:"inlineField"},
                  backColor: {type:"ColorEditor", fieldClass:"inlineField"},
                  label:"Text"                 
               },
               defaults: {
                  fillColor : "#8dd96c",
                  backColor : "#eeeeee",
                  tooltip : true,
                  font:{
                     fontSize : "16px",
                     fontWeight : "bold",
                     fontFamily : "sans-serif",
                     fontColor:"#777777"
                  },
                  size:{
                     width : 500,
                     height : 500
                  }
               }
            }),
      "shapegraph": Backbone.Model.extend({
         schema:
         {
            id : {type:"Text", editorAttrs:{style:"width:100px;"}, fieldClass:"inlineField"},
            type:{
               type: 'Select', options: ["vertical","horizontal","radial"], fieldClass:"inlineField"
            },
            image : {type:'Text', title:"Image URL", editorAttrs:{style:"width:100%;"}},
            font: {type:'NestedModel',model: InfographicSubmodels.FontModel, fieldClass:"NestedModel", help:"can also be WebFonts"},
            size: {type:'NestedModel',model: InfographicSubmodels.SizeModel, fieldClass:"NestedModel"},
            fillColor: {type:"ColorEditor", fieldClass:"inlineField"},
            backColor: {type:"ColorEditor", fieldClass:"inlineField"},
            tooltip:{type:'Checkbox',fieldClass:"inlineField", title:"Display tooltip"},
            description:'Text'
         },
         defaults: {
            fillColor : "#8dd96c",
            backColor : "#eeeeee",
            tooltip : true,
            font:{
               fontSize : "16px",
               fontWeight : "bold",
               fontFamily : "sans-serif",
               fontColor:"#ffffff"
            },
            size:{
               width : 300,
               height : 300
            }
         }
      }),

      "linegraph": Backbone.Model.extend({
         schema:{
             id : {type:"Text", editorAttrs:{style:"width:100px;"}, fieldClass:"inlineBlockField"},
             lineWidth:{type:"Number", fieldClass:"inlineField", editorAttrs:{style:"width:50px;", step:0.1}},
             pointSize:{type:"Number", fieldClass:"inlineField", editorAttrs:{style:"width:50px;", step:0.1}},
             maxValue:{type:"Number", fieldClass:"inlineField", editorAttrs:{style:"width:50px;", step:0.1}},
             padding:{type:"Number", editorAttrs:{style:"width:50px;", step:1}},

             font: {type:'NestedModel',model: InfographicSubmodels.FontModel, fieldClass:"NestedModel", help:"can also be WebFonts"},
             size: {type:'NestedModel',model: InfographicSubmodels.SizeModel, fieldClass:"NestedModel"},

             gridOptions: {type:'NestedModel',model: InfographicSubmodels.GridOptionsModel, fieldClass:"NestedModel"},
             xAxisLabels: {type:'Select',options:["yes","no"]},
             tooltip:{type:'Checkbox',fieldClass:"inlineField", title:"Display tooltip"},
             colors: {type:'List', itemType:'ColorEditor',fieldClass:"inlineField"}
         },
         defaults: {
            fillColor : "#8dd96c",
            backColor : "#eeeeee",
            tooltip : true,
            font:{
               fontSize : "16px",
               fontWeight : "bold",
               fontFamily : "sans-serif",
               fontColor:"#ffffff"
            },
            size:{
               width : 300,
               height : 300
            },
            lineWidth : 10,
            padding:10,
            pointSize:5,
            gridOptions:{
               gridScale:0,
               gridColor:"#cccccc",
               gridLineWidth:0.5,
               gridFontWeight:"bold",
               gridFontSize:"10px",
               gridFontFamily:"arial"
            },
            xAxisLabels:"no",
            colors:["#000000"]
         }
      }),


      "bargraph": Backbone.Model.extend({
         schema:{
             id : {type:"Text", editorAttrs:{style:"width:100px;"}, fieldClass:"inlineBlockField"},
             type : {
                  type: 'Select', options: ["horizontal","vertical"], fieldClass:"inlineField"
               },
             barType : {
                  type: 'Select', options: ["normal","stacked"], fieldClass:"inlineField"
               },
             serieSpacing :{type:"Number", fieldClass:"inlineField", editorAttrs:{style:"width:50px;"}, help:"px"},

             font: {type:'NestedModel',model: InfographicSubmodels.FontModel, fieldClass:"NestedModel", help:"can also be WebFonts"},
             size: {type:'NestedModel',model: InfographicSubmodels.SizeModel, fieldClass:"NestedModel"},

             gridOptions: {type:'NestedModel',model: InfographicSubmodels.GridOptionsModel, fieldClass:"NestedModel"},
             colors: {type:'List', itemType:'ColorEditor',fieldClass:"inlineField"}
         },
         defaults: {
            serieSpacing : 10,
            fillColor : "#8dd96c",
            backColor : "#eeeeee",
            tooltip : true,
            font:{
               fontSize : "10px",
               fontWeight : "bold",
               fontFamily : "sans-serif",
               fontColor : "#000000"
            },
            type : "vertical",
            size:{
               width : 200,
               height : 200
            },
            lineWidth : 10,
            padding:10,
            pointSize:5,
            gridOptions:{
               gridScale:0,
               gridColor:"#cccccc",
               gridLineWidth:0.5,
               gridFontWeight:"bold",
               gridFontSize:"10px",
               gridFontFamily:"arial"
            },
            colors:["#000000"]
         }
      })
};

var InfographicDataModels = {
   transform:function(_cust,_data, _defaults){
      //console.log(_cust);
      var chartType = jQuery(document).find(".chartTypeSelector option:selected").val();
      var inlineValue = "";
      if (chartType == "shapebargraph" || chartType == "shapegraph"){
         inlineValue = " value='"+_data['value']+"' ";
      }
      var str = 
         "[infographic-"+chartType+" "+
         this.attrToString(_cust,_defaults)+
         inlineValue+
         ((typeof(_data.csvUrl)!=="undefined" && _data.csvUrl !=="")?" data_csv='"+_data.csvUrl+"'":"")+
         "]"+
         ((inlineValue == "")?this.dataToString(_data)+"[/infographic-"+chartType+"]":"");
      return str;
   },
   attrToString:function(ob,_defaults){
      var str = "";
      for (key in ob){
         if (typeof(ob[key]) == "object"){
            if (ob[key].length){
               if (!_defaults[key] || ob[key][0] != _defaults[key][0]){
                  str += this.camelToDash(key)+"='" + ob[key].join() + "'";
               }
            }else{
               for (k in ob[key]){
                  if (ob[key][k] != ""){
                     if (!_defaults[key] || ob[key][k] != _defaults[key][k]){
                        str += this.camelToDash(k)+"='"+ob[key][k]+"' ";
                     }
                  }
               }
            }
         }else{
            if (ob[key] != ""){
               if (!_defaults[key] || ob[key] != _defaults[key]){
                  str += this.camelToDash(key)+"='"+ob[key]+"' ";
               }
            }
         }
      }
      return str;
   },
   camelToDash:function (attr){
      return attr.replace(/([a-z])([A-Z])/g, '$1_$2').toLowerCase();
   },
   dataToString:function(ob){
      var chartType = jQuery(document).find(".chartTypeSelector option:selected").val();
      var str = "";
      if (chartType == "piechart"){
         for (var i=0;i<ob.slices.length;i++){
            str += "[ig-pieslice label='"+ob.slices[i].label+"' value='"+ob.slices[i].value+"']";
         }
         return str;
      } else if (chartType == "linegraph"){
         //console.log(ob);
         if (typeof(ob.csvUrl)!=="undefined" && ob.csvUrl !==""){
            return "";
         }
         for (var i=0;i<ob.line.length;i++){
            str += "[ig-line name='"+ob.line[i].name+"' ]";
               for (var j=0;j<ob.line[i].point.length;j++){
                  str += "[ig-point label='"+ob.line[i].point[j].label+"' value='"+ob.line[i].point[j].value+"']";
               }
            str += "[/ig-line]";
         }
         return str;
      } else if (chartType == "bargraph"){
         //console.log(ob);
         for (var i=0;i<ob.barGroup.length;i++){
            str += "[ig-bargroup name='"+ob.barGroup[i].name+"' ]";
               for (var j=0;j<ob.barGroup[i].bar.length;j++){
                  str += "[ig-bar label='"+ob.barGroup[i].bar[j].label+"' value='"+ob.barGroup[i].bar[j].value+"']";
               }
            str += "[/ig-bargroup]";
         }
         return str;
      }



      // for (key in ob){
      //    if (typeof(ob[key]) == "object" && ob[key].length){
      //       for (var i=0;i<ob[key].length;i++){
               
      //          for (k in ob[key][i]){
      //             if (typeof(ob[key][i][k]) == "object" && ob[key][i][k].length){
      //                for (var j=0;j<ob[key][i][k].length;j++){
      //                   str += "[ig-subserie name='"+k+"' ";
      //                   for (kk in ob[key][i][k][j]){
      //                      str += kk+"='"+ob[key][i][k][j][kk]+"' ";
      //                   }
      //                   str += "]";
      //                }
      //                str += "[/ig-data]";
      //             }else{
      //                if (ob[key][i][k]!=""){
      //                   str += "[ig-data "+k+"='"+ob[key][i][k]+"' ]";
      //                }
      //             }
      //          }
               
      //       }
      //    }else{
      //       if (ob[key]!=""){
      //          return "[ig-data "+key+"='"+ob[key]+"' ]";
      //       }
      //    }
      // }

      return str;
   },
   "piechart":
   Backbone.Model.extend(
   {
      schema:{
         slices: {
            type:'List', itemType:'Object', editorAttrs:{style:"display:inline-block"}, 
            subSchema:{label:{type:'Text',editorAttrs:{style:"width:180px;"}, fieldClass:"inlineField"}, value:{type:'Number',fieldClass:"inlineField", editorAttrs:{style:"width:80px;", step:0.1}}}
         }
      }
   }
   ),
   "shapebargraph":
   Backbone.Model.extend(
   {
      schema:{
         value:{type:'Number',fieldClass:"inlineField", editorAttrs:{style:"width:80px;", step:0.1}}
      }
   }
   ),
   "shapegraph":
   Backbone.Model.extend(
   {
      schema:{
         value:{type:'Number',fieldClass:"inlineField", editorAttrs:{style:"width:80px;", step:0.1}}
      }
   }
   ),
   "linegraph":
   Backbone.Model.extend(
   {
      schema:{
         csvUrl:{type:"Text", title:"CSV URL",help:"OR", editorAttrs:{style:"width:100%;"}},
         line: {
            type:'List', itemType:'Object', 
            subSchema:{
               name:{type:'Text',editorAttrs:{style:"width:180px;"}, fieldClass:"inlineField"},
               // label:{type:'Text',editorAttrs:{style:"width:150px;"},fieldClass:"inlineField"}, 
               // value:{type:'Number',fieldClass:"inlineField", editorAttrs:{style:"width:30px;"}}
               point:{
                  type:'List', 
                  itemType:'Object',
                  fieldClass:"serieField",
                  subSchema:{
                     label:{type:'Text',editorAttrs:{style:"width:150px;"}, fieldClass:"inlineField"}, 
                     value:{type:'Number',fieldClass:"inlineField", editorAttrs:{style:"width:80px;"}}
                  }
               }
            }
         },

      }
   }
   ),
   "bargraph":
   Backbone.Model.extend(
   {
      schema:{
         barGroup: {
            type:'List', itemType:'Object', 
            subSchema:{
               name:{type:'Text',editorAttrs:{style:"width:180px;"}, fieldClass:"inlineField"},
               // label:{type:'Text',editorAttrs:{style:"width:150px;"},fieldClass:"inlineField"}, 
               // value:{type:'Number',fieldClass:"inlineField", editorAttrs:{style:"width:30px;"}}
               bar:{
                  type:'List', 
                  itemType:'Object',
                  fieldClass:"serieField",
                  subSchema:{
                     label:{type:'Text',editorAttrs:{style:"width:150px;"}, fieldClass:"inlineField"}, 
                     value:{type:'Number',fieldClass:"inlineField", editorAttrs:{style:"width:80px;"}}
                  }
               }
            }
         },

      }
   }
   )   
};


function InfographicAvailableFonts(){
   var arr=[];jQuery("*").each(function (idx,el){var font = jQuery(el).css("font-family"); font = font.replace(/'/g," "); if (jQuery.inArray(font,arr) < 0){arr.push(font);}});
   return arr;
}